apiVersion: workspace.devfile.io/v1alpha2
kind: DevWorkspaceTemplate
metadata:
  name: che-idea-python-hello-world
spec:
  commands:
    - id: init-container-command
      apply:
        component: idea-rhel8-injector
  events:
    preStart:
      - init-container-command
  components:
    - name: idea-rhel8
      container:
        image: registry.redhat.io/devspaces/udi-rhel8:3.5
        command:
          - /projector/entrypoint-volume.sh
        env:
          - name: PROJECTOR_ASSEMBLY_DIR
            value: /projector
          - name: PROJECTOR_CONFIG_DIR
            value: /home/user/.jetbrains
        volumeMounts:
          - name: projector-volume
            path: /projector
          - name: projector-configuration
            path: /home/user/.jetbrains
          - name: projector-java-configuration
            path: /home/user/.java
        memoryLimit: 6144Mi
        memoryRequest: 2048Mi
        cpuLimit: 2000m
        cpuRequest: 1500m
        endpoints:
          - name: intellij
            attributes:
              type: main
              cookiesAuthEnabled: true
              discoverable: false
              urlRewriteSupported: true
              secure: false
            targetPort: 8887
            exposure: public
            path: /?backgroundColor=434343&wss
            protocol: http
          - name: intellij-redirect-1
            attributes:
              discoverable: false
              urlRewriteSupported: false
            targetPort: 13131
            exposure: public
            protocol: http
          - name: intellij-redirect-2
            attributes:
              discoverable: false
              urlRewriteSupported: false
            targetPort: 13132
            exposure: public
            protocol: http
          - name: intellij-redirect-3
            attributes:
              discoverable: false
              urlRewriteSupported: false
            targetPort: 13133
            exposure: public
            protocol: http
      attributes:
        app.kubernetes.io/component: idea-rhel8-injector
        app.kubernetes.io/part-of: idea-rhel8.eclipse.org
    - name: projector-volume
      volume: {}
    - name: projector-configuration
      volume: {}
    - name: projector-java-configuration
      volume: {}
    - name: idea-rhel8-injector
      container:
        image: registry.redhat.io/devspaces/idea-rhel8:3.5
        command:
          - /projector/entrypoint-init-container.sh
        env:
          - name: PROJECTOR_VOLUME_MOUNT
            value: /projector-volume
          - name: PROJECTOR_ASSEMBLY_DIR
            value: /projector
        volumeMounts:
          - name: projector-volume
            path: /projector-volume
        memoryLimit: 128Mi
        memoryRequest: 32Mi
        cpuLimit: 500m
        cpuRequest: 30m
---
apiVersion: workspace.devfile.io/v1alpha2
kind: DevWorkspace
metadata:
  name: python-hello-world
spec:
  started: true
  template:
    components:
      - name: python
        container:
          image: registry.redhat.io/devspaces/udi-rhel8:3.5
          volumeMounts:
            - name: venv
              path: /home/user/.venv
          memoryLimit: 2G
          mountSources: true
        attributes:
          controller.devfile.io/merge-contribution: true
      - name: venv
        volume:
          size: 1G
    commands:
      - id: run
        exec:
          label: Run the application
          component: python
          workingDir: ${PROJECTS_ROOT}/python-hello-world
          commandLine: >-
            python -m venv .venv && . .venv/bin/activate && python
            hello-world.py
          group:
            kind: run
    projects:
      - name: python-hello-world
        zip:
          location: '{{ INTERNAL_URL }}/resources/v2/python-hello-world.zip'
  contributions:
    - name: editor
      kubernetes:
        name: che-idea-python-hello-world
